## containerd 1.6.6~ds1

=== debian/changelog ===
containerd (1.6.6~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.6~ds1
    CVE-2022-31030: CRI plugin: Host memory exhaustion through ExecSync
  * Update Standards-Version to 4.6.1 (no changes)

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 07 Jun 2022 02:13:49 +0800

containerd (1.6.2~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.2~ds1
    CVE-2022-24769: Default inheritable capabilities for linux container
    should be empty

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 24 Mar 2022 15:47:18 +0800

containerd (1.6.1~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.1~ds1
    CVE-2022-23648: CRI plugin: insecure handling of image volumes
  * Add patch for Debian specific CNI binaries path
  * Run integration without existing daemon

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 03 Mar 2022 03:17:38 +0800

containerd (1.6.0~ds1-5) unstable; urgency=medium

  * Enable cri integration test
  * Add back deprecated types in images/converter.
    Needed by golang-github-containerd-stargz-snapshotter 0.8.0

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 28 Feb 2022 01:10:49 +0800

containerd (1.6.0~ds1-4) unstable; urgency=medium

  * Add missing dependency for autopkgtest
  * Revert "Exclude all cmd pkgs in dev package"
    cmd/ctr/commands are used by golang-github-containerd-stargz-snapshotter

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 27 Feb 2022 19:42:57 +0800

containerd (1.6.0~ds1-3) unstable; urgency=medium

  * Skip failed TestNormalize test
    https://github.com/containerd/containerd/issues/6573

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 27 Feb 2022 03:28:07 +0800

containerd (1.6.0~ds1-2) unstable; urgency=medium

  * Upload to unstable
  * Add patch to ignore missing hugetlb error in tests
  * Exclude all cmd pkgs in dev package
  * Add golang-github-intel-goresctrl-dev to Depends
  * Add patch to fix building with gccgo

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 27 Feb 2022 01:18:47 +0800

containerd (1.6.0~ds1-1) experimental; urgency=medium

  * New upstream version 1.6.0~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Mon, 21 Feb 2022 02:23:42 +0800

containerd (1.5.9~ds1-1) unstable; urgency=medium

  * New upstream version 1.5.9~ds1
    + CVE-2021-43816:
      Fix unprivileged pod using 'hostPath' bypassing SELinux labels

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 06 Jan 2022 01:50:43 +0800

=== debian/control ===
Source: containerd
Section: admin
Priority: optional
Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
Uploaders: Tianon Gravi <tianon@debian.org>,
           Tim Potter <tpot@hpe.com>,
           Shengjing Zhu <zhsj@debian.org>,
Build-Depends: debhelper-compat (= 13),
               dh-golang,
               go-md2man,
               golang-any,
               golang-github-blang-semver-dev,
               golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
               golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
               golang-github-containerd-console-dev,
               golang-github-containerd-continuity-dev (>= 0.0~git20190827.75bee3e~),
               golang-github-containerd-fifo-dev (>= 1.0.0~),
               golang-github-containerd-go-cni-dev (>= 1.0.2~),
               golang-github-containerd-go-runc-dev (>= 0.0~git20190226.7d11b49~),
               golang-github-containerd-ttrpc-dev (>= 0.0~git20190828.92c8520~),
               golang-github-containerd-typeurl-dev,
               golang-github-containernetworking-plugins-dev,
               golang-github-containers-ocicrypt-dev,
               golang-github-coreos-bbolt-dev,
               golang-github-coreos-go-systemd-dev,
               golang-github-davecgh-go-spew-dev,
               golang-github-docker-go-events-dev,
               golang-github-docker-go-metrics-dev,
               golang-github-docker-go-units-dev,
               golang-github-emicklei-go-restful-dev,
               golang-github-fsnotify-fsnotify-dev,
               golang-github-go-logr-logr-dev,
               golang-github-gogo-googleapis-dev (>= 1.4.0~),
               golang-github-gogo-protobuf-dev (>= 1.3.0~),
               golang-github-google-go-cmp-dev,
               golang-github-google-gofuzz-dev,
               golang-github-google-uuid-dev,
               golang-github-gotestyourself-gotest.tools-dev (>= 3.0.0~),
               golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
               golang-github-hashicorp-go-multierror-dev,
               golang-github-imdario-mergo-dev,
               golang-github-intel-goresctrl-dev,
               golang-github-klauspost-compress-dev,
               golang-github-moby-locker-dev,
               golang-github-moby-spdystream-dev,
               golang-github-moby-sys-dev (>= 0.0~git20220215.b8d8fab~),
               golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
               golang-github-opencontainers-image-spec-dev (>= 1.0.2~),
               golang-github-opencontainers-runc-dev (>= 0.1.0~),
               golang-github-opencontainers-runtime-spec-dev,
               golang-github-opencontainers-selinux-dev,
               golang-github-pelletier-go-toml-dev,
               golang-github-pkg-errors-dev,
               golang-github-prometheus-client-golang-dev,
               golang-github-sirupsen-logrus-dev,
               golang-github-spf13-pflag-dev,
               golang-github-tchap-go-patricia-dev,
               golang-github-urfave-cli-dev (>= 1.22.2-4~),
               golang-github-vishvananda-netlink-dev,
               golang-go-zfs-dev,
               golang-golang-x-net-dev,
               golang-golang-x-sync-dev,
               golang-golang-x-sys-dev,
               golang-golang-x-time-dev,
               golang-google-grpc-dev,
               golang-gopkg-inf.v0-dev,
               golang-k8s-sigs-structured-merge-diff-dev,
               golang-k8s-sigs-yaml-dev,
               golang-opentelemetry-otel-dev,
Standards-Version: 4.6.1
Rules-Requires-Root: no
Homepage: https://containerd.io/
Vcs-Git: https://salsa.debian.org/go-team/packages/containerd.git
Vcs-Browser: https://salsa.debian.org/go-team/packages/containerd
XS-Go-Import-Path: github.com/containerd/containerd
Testsuite: autopkgtest-pkg-go

Package: containerd
Architecture: linux-any
Breaks: docker.io (<< 1.12),
Depends: runc (>= 0.1.0~),
         ${misc:Depends},
         ${shlibs:Depends},
Suggests: containernetworking-plugins,
Built-Using: ${misc:Built-Using},
Description: open and reliable container runtime
 Containerd is an industry-standard container runtime with an emphasis on
 simplicity, robustness and portability. It is available as a daemon for
 Linux and Windows, which can manage the complete container life cycle of
 its host system: image transfer and storage, container execution and
 supervision, low-level storage and network attachments, etc.
 .
 Containerd is designed to be embedded into a larger system, rather than
 being used directly by developers or end-users.
 .
 This package contains the binaries.

Package: golang-github-containerd-containerd-dev
Architecture: all
Section: golang
Depends: golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
         golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
         golang-github-containerd-console-dev,
         golang-github-containerd-continuity-dev (>= 0.0~git20190827.75bee3e~),
         golang-github-containerd-fifo-dev (>= 1.0.0~),
         golang-github-containerd-go-cni-dev (>= 1.0.2~),
         golang-github-containerd-go-runc-dev (>= 0.0~git20190226.7d11b49~),
         golang-github-containerd-ttrpc-dev (>= 0.0~git20190828.92c8520~),
         golang-github-containerd-typeurl-dev,
         golang-github-containernetworking-plugins-dev,
         golang-github-coreos-bbolt-dev,
         golang-github-docker-go-events-dev,
         golang-github-docker-go-metrics-dev,
         golang-github-docker-go-units-dev,
         golang-github-gogo-googleapis-dev (>= 1.4.0~),
         golang-github-gogo-protobuf-dev (>= 1.3.0~),
         golang-github-google-uuid-dev,
         golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
         golang-github-hashicorp-go-multierror-dev,
         golang-github-imdario-mergo-dev,
         golang-github-intel-goresctrl-dev,
         golang-github-klauspost-compress-dev,
         golang-github-moby-locker-dev,
         golang-github-moby-sys-dev (>= 0.0~git20220215.b8d8fab~),
         golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
         golang-github-opencontainers-image-spec-dev (>= 1.0.2~),
         golang-github-opencontainers-runc-dev (>= 0.1.0~),
         golang-github-opencontainers-runtime-spec-dev,
         golang-github-opencontainers-selinux-dev,
         golang-github-pelletier-go-toml-dev,
         golang-github-prometheus-client-golang-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-urfave-cli-dev (>= 1.22.2~),
         golang-golang-x-net-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-google-grpc-dev,
         golang-opentelemetry-otel-dev,
         ${misc:Depends},
Description: open and reliable container runtime (development files)
 Containerd is an industry-standard container runtime with an emphasis on
 simplicity, robustness and portability. It is available as a daemon for
 Linux and Windows, which can manage the complete container life cycle of
 its host system: image transfer and storage, container execution and
 supervision, low-level storage and network attachments, etc.
 .
 Containerd is designed to be embedded into a larger system, rather than
 being used directly by developers or end-users.
 .
 This package provides development files.

## containerd 1.6.8~ds1

=== debian/changelog ===
containerd (1.6.8~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.8~ds1 (Closes: #1017917)
  * Remove compatibility patch for
    golang-github-containerd-stargz-snapshotter 0.8.0

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 23 Aug 2022 00:33:54 +0800

## containerd 1.6.9~ds1

=== debian/changelog ===
containerd (1.6.9~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.9~ds1
  * Unvendor klog and go-logr
  * Add golang-k8s-klog-dev to Build-Depends

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 25 Oct 2022 02:52:23 +0800

=== debian/control ===
--- 
+++ 
@@ -64,6 +64,7 @@
                golang-golang-x-time-dev,
                golang-google-grpc-dev,
                golang-gopkg-inf.v0-dev,
+               golang-k8s-klog-dev (>= 2.30.0~),
                golang-k8s-sigs-structured-merge-diff-dev,
                golang-k8s-sigs-yaml-dev,
                golang-opentelemetry-otel-dev,

## containerd 1.6.12~ds1

=== debian/changelog ===
containerd (1.6.12~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.12~ds1
    + CVE-2022-23471: CRI plugin: Fix goroutine leak during Exec

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 08 Dec 2022 10:02:21 +0800

containerd (1.6.11~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.11~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Wed, 07 Dec 2022 10:24:32 +0800

## containerd 1.6.12

=== Makefile ===
#   Copyright The containerd Authors.

#   Licensed under the Apache License, Version 2.0 (the "License");
#   you may not use this file except in compliance with the License.
#   You may obtain a copy of the License at

#       http://www.apache.org/licenses/LICENSE-2.0

#   Unless required by applicable law or agreed to in writing, software
#   distributed under the License is distributed on an "AS IS" BASIS,
#   WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
#   See the License for the specific language governing permissions and
#   limitations under the License.


# Go command to use for build
GO ?= go
INSTALL ?= install

# Root directory of the project (absolute path).
ROOTDIR=$(dir $(abspath $(lastword $(MAKEFILE_LIST))))

# Base path used to install.
# The files will be installed under `$(DESTDIR)/$(PREFIX)`.
# The convention of `DESTDIR` was changed in containerd v1.6.
PREFIX        ?= /usr/local
DATADIR       ?= $(PREFIX)/share
MANDIR        ?= $(DATADIR)/man

TEST_IMAGE_LIST ?=

# Used to populate variables in version package.
VERSION ?= $(shell git describe --match 'v[0-9]*' --dirty='.m' --always)
REVISION=$(shell git rev-parse HEAD)$(shell if ! git diff --no-ext-diff --quiet --exit-code; then echo .m; fi)
PACKAGE=github.com/containerd/containerd
SHIM_CGO_ENABLED ?= 0

ifneq "$(strip $(shell command -v $(GO) 2>/dev/null))" ""
	GOOS ?= $(shell $(GO) env GOOS)
	GOARCH ?= $(shell $(GO) env GOARCH)
else
	ifeq ($(GOOS),)
		# approximate GOOS for the platform if we don't have Go and GOOS isn't
		# set. We leave GOARCH unset, so that may need to be fixed.
		ifeq ($(OS),Windows_NT)
			GOOS = windows
		else
			UNAME_S := $(shell uname -s)
			ifeq ($(UNAME_S),Linux)
				GOOS = linux
			endif
			ifeq ($(UNAME_S),Darwin)
				GOOS = darwin
			endif
			ifeq ($(UNAME_S),FreeBSD)
				GOOS = freebsd
			endif
		endif
	else
		GOOS ?= $$GOOS
		GOARCH ?= $$GOARCH
	endif
endif

ifndef GODEBUG
	EXTRA_LDFLAGS += -s -w
	DEBUG_GO_GCFLAGS :=
	DEBUG_TAGS :=
else
	DEBUG_GO_GCFLAGS := -gcflags=all="-N -l"
	DEBUG_TAGS := static_build
endif

WHALE = "🇩"
ONI = "👹"

RELEASE=containerd-$(VERSION:v%=%)-${GOOS}-${GOARCH}
CRIRELEASE=cri-containerd-$(VERSION:v%=%)-${GOOS}-${GOARCH}
CRICNIRELEASE=cri-containerd-cni-$(VERSION:v%=%)-${GOOS}-${GOARCH}

PKG=github.com/containerd/containerd

# Project binaries.
COMMANDS=ctr containerd containerd-stress
MANPAGES=ctr.8 containerd.8 containerd-config.8 containerd-config.toml.5

ifdef BUILDTAGS
    GO_BUILDTAGS = ${BUILDTAGS}
endif
GO_BUILDTAGS ?=
GO_BUILDTAGS += ${DEBUG_TAGS}
ifneq ($(STATIC),)
	GO_BUILDTAGS += osusergo netgo static_build
endif
GO_TAGS=$(if $(GO_BUILDTAGS),-tags "$(strip $(GO_BUILDTAGS))",)

GO_LDFLAGS=-ldflags '-X $(PKG)/version.Version=$(VERSION) -X $(PKG)/version.Revision=$(REVISION) -X $(PKG)/version.Package=$(PACKAGE) $(EXTRA_LDFLAGS)
ifneq ($(STATIC),)
	GO_LDFLAGS += -extldflags "-static"
endif
GO_LDFLAGS+='

SHIM_GO_LDFLAGS=-ldflags '-X $(PKG)/version.Version=$(VERSION) -X $(PKG)/version.Revision=$(REVISION) -X $(PKG)/version.Package=$(PACKAGE) -extldflags "-static" $(EXTRA_LDFLAGS)'

# Project packages.
PACKAGES=$(shell $(GO) list ${GO_TAGS} ./... | grep -v /vendor/ | grep -v /integration)
API_PACKAGES=$(shell (cd api && $(GO) list ${GO_TAGS} ./... | grep -v /vendor/ | grep -v /integration))
NON_API_PACKAGES=$(shell $(GO) list ${GO_TAGS} ./... | grep -v /vendor/ | grep -v /integration | grep -v "containerd/api")
TEST_REQUIRES_ROOT_PACKAGES=$(filter \
    ${PACKAGES}, \
    $(shell \
	for f in $$(git grep -l testutil.RequiresRoot | grep -v Makefile); do \
		d="$$(dirname $$f)"; \
		[ "$$d" = "." ] && echo "${PKG}" && continue; \
		echo "${PKG}/$$d"; \
	done | sort -u) \
    )

ifdef SKIPTESTS
    PACKAGES:=$(filter-out ${SKIPTESTS},${PACKAGES})
    TEST_REQUIRES_ROOT_PACKAGES:=$(filter-out ${SKIPTESTS},${TEST_REQUIRES_ROOT_PACKAGES})
endif

#Replaces ":" (*nix), ";" (windows) with newline for easy parsing
GOPATHS=$(shell echo ${GOPATH} | tr ":" "\n" | tr ";" "\n")

TESTFLAGS_RACE=
GO_BUILD_FLAGS=
# See Golang issue re: '-trimpath': https://github.com/golang/go/issues/13809
GO_GCFLAGS=$(shell				\
	set -- ${GOPATHS};			\
	echo "-gcflags=-trimpath=$${1}/src";	\
	)

BINARIES=$(addprefix bin/,$(COMMANDS))

#include platform specific makefile
-include Makefile.$(GOOS)

# Flags passed to `go test`
TESTFLAGS ?= $(TESTFLAGS_RACE) $(EXTRA_TESTFLAGS)
TESTFLAGS_PARALLEL ?= 8

# Use this to replace `go test` with, for instance, `gotestsum`
GOTEST ?= $(GO) test

OUTPUTDIR = $(join $(ROOTDIR), _output)
CRIDIR=$(OUTPUTDIR)/cri

.PHONY: clean all AUTHORS build binaries test integration generate protos checkprotos coverage ci check help install uninstall vendor release mandir install-man genman install-cri-deps cri-release cri-cni-release cri-integration install-deps bin/cri-integration.test
.DEFAULT: default

# Forcibly set the default goal to all, in case an include above brought in a rule definition.
.DEFAULT_GOAL := all

all: binaries

check: proto-fmt ## run all linters
	@echo "$(WHALE) $@"
	GOGC=75 golangci-lint run

ci: check binaries checkprotos coverage coverage-integration ## to be used by the CI

AUTHORS: .mailmap .git/HEAD
	git log --format='%aN <%aE>' | sort -fu > $@

generate: protos
	@echo "$(WHALE) $@"
	@PATH="${ROOTDIR}/bin:${PATH}" $(GO) generate -x ${PACKAGES}

protos: bin/protoc-gen-gogoctrd ## generate protobuf
	@echo "$(WHALE) $@"
	@find . -path ./vendor -prune -false -o -name '*.pb.go' | xargs rm
	$(eval TMPDIR := $(shell mktemp -d))
	@mv ${ROOTDIR}/vendor ${TMPDIR}
	@(cd ${ROOTDIR}/api && PATH="${ROOTDIR}/bin:${PATH}" protobuild --quiet ${API_PACKAGES})
	@(PATH="${ROOTDIR}/bin:${PATH}" protobuild --quiet ${NON_API_PACKAGES})
	@mv ${TMPDIR}/vendor ${ROOTDIR}
	@rm -rf ${TMPDIR}

check-protos: protos ## check if protobufs needs to be generated again
	@echo "$(WHALE) $@"
	@test -z "$$(git status --short | grep ".pb.go" | tee /dev/stderr)" || \
		((git diff | cat) && \
		(echo "$(ONI) please run 'make protos' when making changes to proto files" && false))

check-api-descriptors: protos ## check that protobuf changes aren't present.
	@echo "$(WHALE) $@"
	@test -z "$$(git status --short | grep ".pb.txt" | tee /dev/stderr)" || \
		((git diff $$(find . -name '*.pb.txt') | cat) && \
		(echo "$(ONI) please run 'make protos' when making changes to proto files and check-in the generated descriptor file changes" && false))

proto-fmt: ## check format of proto files
	@echo "$(WHALE) $@"
	@test -z "$$(find . -path ./vendor -prune -o -path ./protobuf/google/rpc -prune -o -name '*.proto' -type f -exec grep -Hn -e "^ " {} \; | tee /dev/stderr)" || \
		(echo "$(ONI) please indent proto files with tabs only" && false)
	@test -z "$$(find . -path ./vendor -prune -o -name '*.proto' -type f -exec grep -Hn "Meta meta = " {} \; | grep -v '(gogoproto.nullable) = false' | tee /dev/stderr)" || \
		(echo "$(ONI) meta fields in proto files must have option (gogoproto.nullable) = false" && false)

build: ## build the go packages
	@echo "$(WHALE) $@"
	@$(GO) build ${DEBUG_GO_GCFLAGS} ${GO_GCFLAGS} ${GO_BUILD_FLAGS} ${EXTRA_FLAGS} ${GO_LDFLAGS} ${PACKAGES}

test: ## run tests, except integration tests and tests that require root
	@echo "$(WHALE) $@"
	@$(GOTEST) ${TESTFLAGS} ${PACKAGES}

root-test: ## run tests, except integration tests
	@echo "$(WHALE) $@"
	@$(GOTEST) ${TESTFLAGS} ${TEST_REQUIRES_ROOT_PACKAGES} -test.root

integration: ## run integration tests
	@echo "$(WHALE) $@"
	@cd "${ROOTDIR}/integration/client" && $(GO) mod download && $(GOTEST) -v ${TESTFLAGS} -test.root -parallel ${TESTFLAGS_PARALLEL} .

# TODO integrate cri integration bucket with coverage
bin/cri-integration.test:
	@echo "$(WHALE) $@"
	@$(GO) test -c ./integration -o bin/cri-integration.test

cri-integration: binaries bin/cri-integration.test ## run cri integration tests
	@echo "$(WHALE) $@"
	@bash -x ./script/test/cri-integration.sh
	@rm -rf bin/cri-integration.test

# build runc shimv2 with failpoint control, only used by integration test
bin/containerd-shim-runc-fp-v1: integration/failpoint/cmd/containerd-shim-runc-fp-v1 FORCE
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./integration/failpoint/cmd/containerd-shim-runc-fp-v1

# build CNI bridge plugin wrapper with failpoint support, only used by integration test
bin/cni-bridge-fp: integration/failpoint/cmd/cni-bridge-fp FORCE
	@echo "$(WHALE) $@"
	@$(GO) build ${GO_BUILD_FLAGS} -o $@ ./integration/failpoint/cmd/cni-bridge-fp

benchmark: ## run benchmarks tests
	@echo "$(WHALE) $@"
	@$(GO) test ${TESTFLAGS} -bench . -run Benchmark -test.root

FORCE:

define BUILD_BINARY
@echo "$(WHALE) $@"
@$(GO) build ${DEBUG_GO_GCFLAGS} ${GO_GCFLAGS} ${GO_BUILD_FLAGS} -o $@ ${GO_LDFLAGS} ${GO_TAGS}  ./$<
endef

# Build a binary from a cmd.
bin/%: cmd/% FORCE
	$(call BUILD_BINARY)

bin/containerd-shim: cmd/containerd-shim FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim

bin/containerd-shim-runc-v1: cmd/containerd-shim-runc-v1 FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim-runc-v1

bin/containerd-shim-runc-v2: cmd/containerd-shim-runc-v2 FORCE # set !cgo and omit pie for a static shim build: https://github.com/golang/go/issues/17789#issuecomment-258542220
	@echo "$(WHALE) $@"
	@CGO_ENABLED=${SHIM_CGO_ENABLED} $(GO) build ${GO_BUILD_FLAGS} -o $@ ${SHIM_GO_LDFLAGS} ${GO_TAGS} ./cmd/containerd-shim-runc-v2

binaries: $(BINARIES) ## build binaries
	@echo "$(WHALE) $@"

man: mandir $(addprefix man/,$(MANPAGES))
	@echo "$(WHALE) $@"

mandir:
	@mkdir -p man

# Kept for backwards compatibility
genman: man/containerd.8 man/ctr.8

man/containerd.8: FORCE
	@echo "$(WHALE) $@"
	$(GO) run -mod=readonly ${GO_TAGS} cmd/gen-manpages/main.go $(@F) $(@D)

man/ctr.8: FORCE
	@echo "$(WHALE) $@"
	$(GO) run -mod=readonly ${GO_TAGS} cmd/gen-manpages/main.go $(@F) $(@D)

man/%: docs/man/%.md FORCE
	@echo "$(WHALE) $@"
	go-md2man -in "$<" -out "$@"

define installmanpage
$(INSTALL) -d $(DESTDIR)$(MANDIR)/man$(2);
gzip -c $(1) >$(DESTDIR)$(MANDIR)/man$(2)/$(3).gz;
endef

install-man: man
	@echo "$(WHALE) $@"
	$(foreach manpage,$(addprefix man/,$(MANPAGES)), $(call installmanpage,$(manpage),$(subst .,,$(suffix $(manpage))),$(notdir $(manpage))))


releases/$(RELEASE).tar.gz: $(BINARIES)
	@echo "$(WHALE) $@"
	@rm -rf releases/$(RELEASE) releases/$(RELEASE).tar.gz
	@$(INSTALL) -d releases/$(RELEASE)/bin
	@$(INSTALL) $(BINARIES) releases/$(RELEASE)/bin
	@tar -czf releases/$(RELEASE).tar.gz -C releases/$(RELEASE) bin
	@rm -rf releases/$(RELEASE)

release: releases/$(RELEASE).tar.gz
	@echo "$(WHALE) $@"
	@cd releases && sha256sum $(RELEASE).tar.gz >$(RELEASE).tar.gz.sha256sum

# install of cri deps into release output directory
ifeq ($(GOOS),windows)
install-cri-deps: $(BINARIES)
	$(INSTALL) -d $(CRIDIR)
	DESTDIR=$(CRIDIR) script/setup/install-cni-windows
	cp bin/* $(CRIDIR)
else
install-cri-deps: $(BINARIES)
	@rm -rf ${CRIDIR}
	@$(INSTALL) -d ${CRIDIR}/usr/local/bin
	@$(INSTALL) -D -m 755 bin/* ${CRIDIR}/usr/local/bin
	@$(INSTALL) -d ${CRIDIR}/opt/containerd/cluster
	@cp -r contrib/gce ${CRIDIR}/opt/containerd/cluster/
	@$(INSTALL) -d ${CRIDIR}/etc/systemd/system
	@$(INSTALL) -m 644 containerd.service ${CRIDIR}/etc/systemd/system
	echo "CONTAINERD_VERSION: '$(VERSION:v%=%)'" | tee ${CRIDIR}/opt/containerd/cluster/version

	DESTDIR=$(CRIDIR) script/setup/install-runc
	DESTDIR=$(CRIDIR) script/setup/install-cni
	DESTDIR=$(CRIDIR) script/setup/install-critools
	DESTDIR=$(CRIDIR) script/setup/install-imgcrypt

	@$(INSTALL) -d $(CRIDIR)/bin

=== vendor/go.opentelemetry.io/otel/Makefile ===
# Copyright The OpenTelemetry Authors
#
# Licensed under the Apache License, Version 2.0 (the "License");
# you may not use this file except in compliance with the License.
# You may obtain a copy of the License at
#
#     http://www.apache.org/licenses/LICENSE-2.0
#
# Unless required by applicable law or agreed to in writing, software
# distributed under the License is distributed on an "AS IS" BASIS,
# WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
# See the License for the specific language governing permissions and
# limitations under the License.

EXAMPLES := $(shell ./get_main_pkgs.sh ./example)
TOOLS_MOD_DIR := ./internal/tools

# All source code and documents. Used in spell check.
ALL_DOCS := $(shell find . -name '*.md' -type f | sort)
# All directories with go.mod files related to opentelemetry library. Used for building, testing and linting.
ALL_GO_MOD_DIRS := $(filter-out $(TOOLS_MOD_DIR), $(shell find . -type f -name 'go.mod' -exec dirname {} \; | egrep -v '^./example' | sort)) $(shell find ./example -type f -name 'go.mod' -exec dirname {} \; | sort)
ALL_COVERAGE_MOD_DIRS := $(shell find . -type f -name 'go.mod' -exec dirname {} \; | egrep -v '^./example|^$(TOOLS_MOD_DIR)' | sort)

GO = go
TIMEOUT = 60

.DEFAULT_GOAL := precommit

.PHONY: precommit ci
precommit: dependabot-check license-check lint build examples test-default
ci: precommit check-clean-work-tree test-coverage

# Tools

TOOLS = $(CURDIR)/.tools

$(TOOLS):
	@mkdir -p $@
$(TOOLS)/%: | $(TOOLS)
	cd $(TOOLS_MOD_DIR) && \
	$(GO) build -o $@ $(PACKAGE)

MULTIMOD = $(TOOLS)/multimod
$(TOOLS)/multimod: PACKAGE=go.opentelemetry.io/build-tools/multimod

SEMCONVGEN = $(TOOLS)/semconvgen
$(TOOLS)/semconvgen: PACKAGE=go.opentelemetry.io/build-tools/semconvgen

CROSSLINK = $(TOOLS)/crosslink
$(TOOLS)/crosslink: PACKAGE=go.opentelemetry.io/otel/$(TOOLS_MOD_DIR)/crosslink

GOLANGCI_LINT = $(TOOLS)/golangci-lint
$(TOOLS)/golangci-lint: PACKAGE=github.com/golangci/golangci-lint/cmd/golangci-lint

MISSPELL = $(TOOLS)/misspell
$(TOOLS)/misspell: PACKAGE=github.com/client9/misspell/cmd/misspell

GOCOVMERGE = $(TOOLS)/gocovmerge
$(TOOLS)/gocovmerge: PACKAGE=github.com/wadey/gocovmerge

STRINGER = $(TOOLS)/stringer
$(TOOLS)/stringer: PACKAGE=golang.org/x/tools/cmd/stringer

PORTO = $(TOOLS)/porto
$(TOOLS)/porto: PACKAGE=github.com/jcchavezs/porto/cmd/porto

GOJQ = $(TOOLS)/gojq
$(TOOLS)/gojq: PACKAGE=github.com/itchyny/gojq/cmd/gojq

.PHONY: tools
tools: $(CROSSLINK) $(GOLANGCI_LINT) $(MISSPELL) $(GOCOVMERGE) $(STRINGER) $(PORTO) $(GOJQ) $(SEMCONVGEN) $(MULTIMOD)

# Build

.PHONY: examples generate build
examples:
	@set -e; for dir in $(EXAMPLES); do \
	  echo "$(GO) build $${dir}/..."; \
	  (cd "$${dir}" && \
	   $(GO) build .); \
	done

generate: $(STRINGER) $(PORTO)
	set -e; for dir in $(ALL_GO_MOD_DIRS); do \
	  echo "$(GO) generate $${dir}/..."; \
	  (cd "$${dir}" && \
	    PATH="$(TOOLS):$${PATH}" $(GO) generate ./... && \
		$(PORTO) -w .); \
	done

build: generate
	# Build all package code including testing code.
	set -e; for dir in $(ALL_GO_MOD_DIRS); do \
	  echo "$(GO) build $${dir}/..."; \
	  (cd "$${dir}" && \
	    $(GO) build ./... && \
		$(GO) list ./... \
		  | grep -v third_party \
		  | xargs $(GO) test -vet=off -run xxxxxMatchNothingxxxxx >/dev/null); \
	done

# Tests

TEST_TARGETS := test-default test-bench test-short test-verbose test-race
.PHONY: $(TEST_TARGETS) test
test-default: ARGS=-v -race
test-bench:   ARGS=-run=xxxxxMatchNothingxxxxx -test.benchtime=1ms -bench=.
test-short:   ARGS=-short
test-verbose: ARGS=-v
test-race:    ARGS=-race
$(TEST_TARGETS): test
test:
	@set -e; for dir in $(ALL_GO_MOD_DIRS); do \
	  echo "$(GO) test -timeout $(TIMEOUT)s $(ARGS) $${dir}/..."; \
	  (cd "$${dir}" && \
	    $(GO) list ./... \
		  | grep -v third_party \
		  | xargs $(GO) test -timeout $(TIMEOUT)s $(ARGS)); \
	done

COVERAGE_MODE    = atomic
COVERAGE_PROFILE = coverage.out
.PHONY: test-coverage
test-coverage: | $(GOCOVMERGE)
	@set -e; \
	printf "" > coverage.txt; \
	for dir in $(ALL_COVERAGE_MOD_DIRS); do \
	  echo "$(GO) test -coverpkg=go.opentelemetry.io/otel/... -covermode=$(COVERAGE_MODE) -coverprofile="$(COVERAGE_PROFILE)" $${dir}/..."; \
	  (cd "$${dir}" && \
	    $(GO) list ./... \
	    | grep -v third_party \
	    | xargs $(GO) test -coverpkg=./... -covermode=$(COVERAGE_MODE) -coverprofile="$(COVERAGE_PROFILE)" && \
	  $(GO) tool cover -html=coverage.out -o coverage.html); \
	done; \
	$(GOCOVMERGE) $$(find . -name coverage.out) > coverage.txt

.PHONY: lint
lint: misspell lint-modules | $(GOLANGCI_LINT)
	set -e; for dir in $(ALL_GO_MOD_DIRS); do \
	  echo "golangci-lint in $${dir}"; \
	  (cd "$${dir}" && \
	    $(GOLANGCI_LINT) run --fix && \
	    $(GOLANGCI_LINT) run); \
	done

.PHONY: vanity-import-check
vanity-import-check: | $(PORTO)
	$(PORTO) --include-internal -l .

.PHONY: misspell
misspell: | $(MISSPELL)
	$(MISSPELL) -w $(ALL_DOCS)

.PHONY: lint-modules
lint-modules: | $(CROSSLINK)
	set -e; for dir in $(ALL_GO_MOD_DIRS) $(TOOLS_MOD_DIR); do \
	  echo "$(GO) mod tidy in $${dir}"; \
	  (cd "$${dir}" && \
	    $(GO) mod tidy); \
	done
	echo "cross-linking all go modules"
	$(CROSSLINK)

.PHONY: license-check
license-check:
	@licRes=$$(for f in $$(find . -type f \( -iname '*.go' -o -iname '*.sh' \) ! -path '**/third_party/*') ; do \
	           awk '/Copyright The OpenTelemetry Authors|generated|GENERATED/ && NR<=3 { found=1; next } END { if (!found) print FILENAME }' $$f; \
	   done); \
	   if [ -n "$${licRes}" ]; then \
	           echo "license header checking failed:"; echo "$${licRes}"; \
	           exit 1; \
	   fi

.PHONY: dependabot-check
dependabot-check:
	@result=$$( \
		for f in $$( find . -type f -name go.mod -exec dirname {} \; | sed 's/^.//' ); \
			do grep -q "directory: \+$$f" .github/dependabot.yml \
			|| echo "$$f"; \
		done; \
	); \
	if [ -n "$$result" ]; then \
		echo "missing go.mod dependabot check:"; echo "$$result"; \
		echo "new modules need to be added to the .github/dependabot.yml file"; \
		exit 1; \
	fi

.PHONY: check-clean-work-tree
check-clean-work-tree:
	@if ! git diff --quiet; then \
	  echo; \
	  echo 'Working tree is not clean, did you forget to run "make precommit"?'; \
	  echo; \
	  git status; \
	  exit 1; \
	fi

.PHONY: prerelease
prerelease: | $(MULTIMOD)
	@[ "${MODSET}" ] || ( echo ">> env var MODSET is not set"; exit 1 )
	$(MULTIMOD) verify && $(MULTIMOD) prerelease -m ${MODSET}

COMMIT ?= "HEAD"
.PHONY: add-tags
add-tags: | $(MULTIMOD)
	@[ "${MODSET}" ] || ( echo ">> env var MODSET is not set"; exit 1 )
	$(MULTIMOD) verify && $(MULTIMOD) tag -m ${MODSET} -c ${COMMIT}

=== debian/changelog ===
containerd (1.6.12-0ubuntu3) lunar; urgency=medium

  * d/p/skip-test-setting-OOM-score-to-negative-number-in-unprivileged-mode.patch:
    fix a FTBFS in Ubuntu builders only.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 10 Apr 2023 15:42:57 -0300

containerd (1.6.12-0ubuntu2) lunar; urgency=medium

  * Add unvendored dependencies to golang-github-containerd-containerd-dev.
    Ideally containerd should be unvendored like in Debian. (LP: #1998847)

 -- Benjamin Drung <bdrung@ubuntu.com>  Tue, 13 Dec 2022 11:52:06 +0100

containerd (1.6.12-0ubuntu1) lunar; urgency=medium

  * New upstream release.
    - Fixes CVE-2022-23471.

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Mon, 12 Dec 2022 11:55:18 -0300

containerd (1.6.10-0ubuntu1) lunar; urgency=medium

  * New upstream release (LP: #1993392).

 -- Lucas Kanashiro <kanashiro@ubuntu.com>  Wed, 16 Nov 2022 12:04:51 -0300

=== debian/control ===
Source: containerd
Section: admin
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
Uploaders: Tianon Gravi <tianon@debian.org>
Build-Depends: debhelper (>= 11),
               dh-golang,
               go-md2man,
               golang-go,
               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
               libseccomp-dev,
               pkg-config
Standards-Version: 3.9.7
Homepage: https://containerd.io
Vcs-Git: https://github.com/tianon/debian-containerd.git -b ubuntu
Vcs-Browser: https://github.com/tianon/debian-containerd/tree/ubuntu
XS-Go-Import-Path: github.com/containerd/containerd

Package: containerd
Architecture: linux-any
Depends: runc (>= 1.0.0~rc2~), ${misc:Depends}, ${shlibs:Depends}
Breaks: docker.io (<< 19.03.13-0ubuntu4)
Built-Using: ${misc:Built-Using}
Description: daemon to control runC
 Containerd is a daemon to control runC, built for performance and density.
 Containerd leverages runC's advanced features such as seccomp and user
 namespace support as well as checkpoint and restore for cloning and live
 migration of containers.
 .
 This package contains the binaries.

Package: golang-github-containerd-containerd-dev
Architecture: all
Depends: golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
         golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
         golang-github-containerd-console-dev,
         golang-github-containerd-continuity-dev (>= 0.0~git20190827.75bee3e~),
         golang-github-containerd-fifo-dev (>= 1.0.0~),
         golang-github-containerd-go-cni-dev (>= 1.0.2~),
         golang-github-containerd-go-runc-dev (>= 0.0~git20190226.7d11b49~),
         golang-github-containerd-ttrpc-dev (>= 0.0~git20190828.92c8520~),
         golang-github-containerd-typeurl-dev,
         golang-github-containernetworking-plugins-dev,
         golang-github-coreos-bbolt-dev,
         golang-github-docker-go-events-dev,
         golang-github-docker-go-metrics-dev,
         golang-github-docker-go-units-dev,
         golang-github-gogo-googleapis-dev (>= 1.4.0~),
         golang-github-gogo-protobuf-dev (>= 1.3.0~),
         golang-github-google-uuid-dev,
         golang-github-gotestyourself-gotest.tools-dev (>= 3.0.0~),
         golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
         golang-github-hashicorp-go-multierror-dev,
         golang-github-imdario-mergo-dev,
         golang-github-intel-goresctrl-dev,
         golang-github-klauspost-compress-dev,
         golang-github-moby-locker-dev,
         golang-github-moby-sys-dev (>= 0.0~git20220215.b8d8fab~),
         golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
         golang-github-opencontainers-image-spec-dev (>= 1.0.2~),
         golang-github-opencontainers-runc-dev (>= 0.1.0~),
         golang-github-opencontainers-runtime-spec-dev,
         golang-github-opencontainers-selinux-dev,
         golang-github-pelletier-go-toml-dev,
         golang-github-prometheus-client-golang-dev,
         golang-github-sirupsen-logrus-dev,
         golang-github-urfave-cli-dev (>= 1.22.2~),
         golang-golang-x-net-dev,
         golang-golang-x-sync-dev,
         golang-golang-x-sys-dev,
         golang-google-grpc-dev (>= 1.30),
         golang-opentelemetry-otel-dev,
         ${misc:Depends}
Description: runC develpoment files
 Containerd is a daemon to control runC, built for performance and density.
 Containerd leverages runC's advanced features such as seccomp and user
 namespace support as well as checkpoint and restore for cloning and live
 migration of containers.
 .
 This package provides development files.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/architecture.mk

# temporary build path (see http://golang.org/doc/code.html#GOPATH)
OUR_GOPATH := $(CURDIR)/.gopath
export GOPATH := $(OUR_GOPATH)
export GOCACHE := $(CURDIR)/.gocache

# https://blog.golang.org/go116-module-changes (TODO figure out a new solution for Go 1.17+)
export GO111MODULE := auto

# riscv64 doesn't support cgo
# https://github.com/golang/go/issues/36641
ifeq (riscv64, $(DEB_BUILD_ARCH))
TAGS += no_btrfs
SKIP += github.com/containerd/containerd/snapshots/btrfs
endif

# build explicitly against Go 1.13 (for now):
#   https://github.com/containerd/containerd/issues/4509
#   https://github.com/containerd/containerd/pull/4050
#   https://github.com/golang/go/issues/37942
# (containerd 1.4+ and Go 1.15+ can go back to "golang-go")
export PATH := /usr/lib/go-1.13/bin:$(PATH)

override_dh_gencontrol:
	# use "dh_golang" to generate "misc:Built-Using" (via "go list")
	DH_GOLANG_BUILDPKG=' \
		-tags "$(TAGS)" \
		github.com/containerd/containerd/cmd/containerd \
		github.com/containerd/containerd/cmd/containerd-shim \
		github.com/containerd/containerd/cmd/containerd-shim-runc-v1 \
		github.com/containerd/containerd/cmd/containerd-shim-runc-v2 \
		github.com/containerd/containerd/cmd/containerd-stress \
		github.com/containerd/containerd/cmd/ctr \
	' dh_golang --builddirectory='$(OUR_GOPATH:$(CURDIR)/%=%)'
	dh_gencontrol

override_dh_auto_configure:
	# copy pristine source for "/usr/share/gocode" to get into "golang-github-containerd-containerd-dev" before we muddy it with build artifacts, etc
	mkdir -p .pristine-source
	tar -c --exclude=debian --exclude=.pc --exclude=.pristine-source --exclude=vendor . | tar -xC .pristine-source
	# set up GOPATH symlink farm
	mkdir -p '$(OUR_GOPATH)/src/github.com/containerd'
	ln -sfT '$(CURDIR)' '$(OUR_GOPATH)/src/github.com/containerd/containerd'

override_dh_auto_build:
	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' \
		&& make \
			LDFLAGS='' \
			VERSION='$(shell dpkg-parsechangelog -SVersion)' \
			REVISION='' \
			BUILDTAGS='$(TAGS)' \
		&& make man

override_dh_auto_test:
ifneq (arm, $(DEB_HOST_ARCH_CPU)) # skip the tests on armhf ("--- FAIL: TestParseSelector/linux (0.00s)  platforms_test.go:292: arm support not fully implemented: not implemented")
	cd '$(OUR_GOPATH)/src/github.com/containerd/containerd' && make test SKIPTESTS='$(SKIP)'
endif

override_dh_auto_install:
	make install DESTDIR='$(CURDIR)/debian/tmp' PREFIX='/usr'
	make install-man DESTDIR='$(CURDIR)/debian/tmp' PREFIX='/usr'
	mkdir -p debian/tmp/usr/share/gocode/src/github.com/containerd \
		&& mv .pristine-source debian/tmp/usr/share/gocode/src/github.com/containerd/containerd

override_dh_installsystemd:
	dh_installsystemd
	# replace "/usr/local/bin/containerd" with "/usr/bin/containerd" in our systemd service file
	grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service \
		&& sed -i 's!/usr/local/bin/containerd!/usr/bin/containerd!g' debian/*/lib/systemd/system/containerd.service \
		&& ! grep '/usr/local/bin/containerd' debian/*/lib/systemd/system/containerd.service

%:
	dh $@

## containerd 1.6.16~ds1

=== debian/changelog ===
containerd (1.6.16~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.16~ds1
  * Only track 1.6 LTS version in uscan watch file
  * Drop "Skip failed TestUpdateOCILinuxResource" patch, fixed by
    https://github.com/containerd/containerd/commit/91a68edd

 -- Shengjing Zhu <zhsj@debian.org>  Sun, 29 Jan 2023 03:07:20 +0800

containerd (1.6.14~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.14~ds1
  * Update Standards-Version to 4.6.2 (no changes)
  * Skip failed TestUpdateOCILinuxResource since schroot doesn't have cgroup

 -- Shengjing Zhu <zhsj@debian.org>  Tue, 20 Dec 2022 10:30:50 +0800

containerd (1.6.13~ds1-1) unstable; urgency=medium

  [ Benjamin Drung ]
  * Bump golang-google-grpc-dev to >= 1.30.
  * Let the dev package depend on golang-github-gotestyourself-gotest.tools-dev
    `pkg/testutil/helpers_unix.go` uses `gotest.tools/v3/assert` and
    therefore golang-github-containerd-containerd-dev needs to depend on
    golang-github-gotestyourself-gotest.tools-dev.

  [ Shengjing Zhu ]
  * New upstream version 1.6.13~ds1

 -- Shengjing Zhu <zhsj@debian.org>  Fri, 16 Dec 2022 02:42:08 +0800

## containerd 1.6.17~ds1

=== debian/changelog ===
containerd (1.6.17~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.17~ds1
  * Add missing failpoint binaries in cri-integration autopkgtest

 -- Shengjing Zhu <zhsj@debian.org>  Sat, 11 Feb 2023 02:01:05 +0800

## containerd 1.6.18~ds1

=== debian/changelog ===
containerd (1.6.18~ds1-1) unstable; urgency=medium

  * New upstream version 1.6.18~ds1
    + CVE-2023-25153: OCI image importer memory exhaustion
    + CVE-2023-25173: Supplementary groups are not set up properly
  * Install cni-bridge-fp to /usr/lib/cni in autopkgtest

 -- Shengjing Zhu <zhsj@debian.org>  Thu, 16 Feb 2023 07:16:20 +0800

=== debian/control ===
--- 
+++ 
@@ -1,37 +1,104 @@
 Source: containerd
 Section: admin
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Go Packaging Team <pkg-go-maintainers@lists.alioth.debian.org>
-Uploaders: Tianon Gravi <tianon@debian.org>
-Build-Depends: debhelper (>= 11),
+Maintainer: Debian Go Packaging Team <team+pkg-go@tracker.debian.org>
+Uploaders: Tianon Gravi <tianon@debian.org>,
+           Tim Potter <tpot@hpe.com>,
+           Shengjing Zhu <zhsj@debian.org>,
+Build-Depends: debhelper-compat (= 13),
                dh-golang,
                go-md2man,
-               golang-go,
-               libbtrfs-dev | btrfs-progs (<< 4.16.1~),
-               libseccomp-dev,
-               pkg-config
-Standards-Version: 3.9.7
-Homepage: https://containerd.io
-Vcs-Git: https://github.com/tianon/debian-containerd.git -b ubuntu
-Vcs-Browser: https://github.com/tianon/debian-containerd/tree/ubuntu
+               golang-any,
+               golang-github-blang-semver-dev,
+               golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
+               golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
+               golang-github-containerd-console-dev,
+               golang-github-containerd-continuity-dev (>= 0.0~git20190827.75bee3e~),
+               golang-github-containerd-fifo-dev (>= 1.0.0~),
+               golang-github-containerd-go-cni-dev (>= 1.0.2~),
+               golang-github-containerd-go-runc-dev (>= 0.0~git20190226.7d11b49~),
+               golang-github-containerd-ttrpc-dev (>= 0.0~git20190828.92c8520~),
+               golang-github-containerd-typeurl-dev,
+               golang-github-containernetworking-plugins-dev,
+               golang-github-containers-ocicrypt-dev,
+               golang-github-coreos-bbolt-dev,
+               golang-github-coreos-go-systemd-dev,
+               golang-github-davecgh-go-spew-dev,
+               golang-github-docker-go-events-dev,
+               golang-github-docker-go-metrics-dev,
+               golang-github-docker-go-units-dev,
+               golang-github-emicklei-go-restful-dev,
+               golang-github-fsnotify-fsnotify-dev,
+               golang-github-go-logr-logr-dev,
+               golang-github-gogo-googleapis-dev (>= 1.4.0~),
+               golang-github-gogo-protobuf-dev (>= 1.3.0~),
+               golang-github-google-go-cmp-dev,
+               golang-github-google-gofuzz-dev,
+               golang-github-google-uuid-dev,
+               golang-github-gotestyourself-gotest.tools-dev (>= 3.0.0~),
+               golang-github-grpc-ecosystem-go-grpc-prometheus-dev,
+               golang-github-hashicorp-go-multierror-dev,
+               golang-github-imdario-mergo-dev,
+               golang-github-intel-goresctrl-dev,
+               golang-github-klauspost-compress-dev,
+               golang-github-moby-locker-dev,
+               golang-github-moby-spdystream-dev,
+               golang-github-moby-sys-dev (>= 0.0~git20220215.b8d8fab~),
+               golang-github-opencontainers-go-digest-dev (>= 1.0.0~),
+               golang-github-opencontainers-image-spec-dev (>= 1.0.2~),
+               golang-github-opencontainers-runc-dev (>= 0.1.0~),
+               golang-github-opencontainers-runtime-spec-dev,
+               golang-github-opencontainers-selinux-dev,
+               golang-github-pelletier-go-toml-dev,
+               golang-github-pkg-errors-dev,
+               golang-github-prometheus-client-golang-dev,
+               golang-github-sirupsen-logrus-dev,
+               golang-github-spf13-pflag-dev,
+               golang-github-tchap-go-patricia-dev,
+               golang-github-urfave-cli-dev (>= 1.22.2-4~),
+               golang-github-vishvananda-netlink-dev,
+               golang-go-zfs-dev,
+               golang-golang-x-net-dev,
+               golang-golang-x-sync-dev,
+               golang-golang-x-sys-dev,
+               golang-golang-x-time-dev,
+               golang-google-grpc-dev (>= 1.30),
+               golang-gopkg-inf.v0-dev,
+               golang-k8s-klog-dev (>= 2.30.0~),
+               golang-k8s-sigs-structured-merge-diff-dev,
+               golang-k8s-sigs-yaml-dev,
+               golang-opentelemetry-otel-dev,
+Standards-Version: 4.6.2
+Rules-Requires-Root: no
+Homepage: https://containerd.io/
+Vcs-Git: https://salsa.debian.org/go-team/packages/containerd.git
+Vcs-Browser: https://salsa.debian.org/go-team/packages/containerd
 XS-Go-Import-Path: github.com/containerd/containerd
+Testsuite: autopkgtest-pkg-go
 
 Package: containerd
 Architecture: linux-any
-Depends: runc (>= 1.0.0~rc2~), ${misc:Depends}, ${shlibs:Depends}
-Breaks: docker.io (<< 19.03.13-0ubuntu4)
-Built-Using: ${misc:Built-Using}
-Description: daemon to control runC
- Containerd is a daemon to control runC, built for performance and density.
- Containerd leverages runC's advanced features such as seccomp and user
- namespace support as well as checkpoint and restore for cloning and live
- migration of containers.
+Breaks: docker.io (<< 1.12),
+Depends: runc (>= 0.1.0~),
+         ${misc:Depends},
+         ${shlibs:Depends},
+Suggests: containernetworking-plugins,
+Built-Using: ${misc:Built-Using},
+Description: open and reliable container runtime
+ Containerd is an industry-standard container runtime with an emphasis on
+ simplicity, robustness and portability. It is available as a daemon for
+ Linux and Windows, which can manage the complete container life cycle of
+ its host system: image transfer and storage, container execution and
+ supervision, low-level storage and network attachments, etc.
+ .
+ Containerd is designed to be embedded into a larger system, rather than
+ being used directly by developers or end-users.
  .
  This package contains the binaries.
 
 Package: golang-github-containerd-containerd-dev
 Architecture: all
+Section: golang
 Depends: golang-github-containerd-btrfs-dev (>= 0.0~git20200117.1539353~),
          golang-github-containerd-cgroups-dev (>= 0.0~git20200817.7a3c009~),
          golang-github-containerd-console-dev,
@@ -71,11 +138,15 @@
          golang-golang-x-sys-dev,
          golang-google-grpc-dev (>= 1.30),
          golang-opentelemetry-otel-dev,
-         ${misc:Depends}
-Description: runC develpoment files
- Containerd is a daemon to control runC, built for performance and density.
- Containerd leverages runC's advanced features such as seccomp and user
- namespace support as well as checkpoint and restore for cloning and live
- migration of containers.
+         ${misc:Depends},
+Description: open and reliable container runtime (development files)
+ Containerd is an industry-standard container runtime with an emphasis on
+ simplicity, robustness and portability. It is available as a daemon for
+ Linux and Windows, which can manage the complete container life cycle of
+ its host system: image transfer and storage, container execution and
+ supervision, low-level storage and network attachments, etc.
+ .
+ Containerd is designed to be embedded into a larger system, rather than
+ being used directly by developers or end-users.
  .
  This package provides development files.
